<head>
<style>

.node {
  stroke: #fff;
  stroke-width: 1.5px;
}

.link {
  stroke: #999;
  stroke-opacity: .6;
}

a.tooltip{
    position:relative;
}
a.tooltip::before {
    content: attr(data-tooltip) ;
    font-size: 12px;
    position:absolute;
    z-index: 999;
    width: 500px;
    white-space:wrap;
    bottom:9999px;
    left: -300px;
    background:#ffffcc;
    color:#000000;
    padding:0px 7px;
    line-height: 24px;
    height: 48px;
    opacity: 0;
    border-radius: 10px;
}
a.tooltip:hover::before {
    opacity: 1;
    top:22px;
}
a.tooltip:hover::after {
    content: "";
    opacity: 1;
    width: 0; 
    height: 0; 
    border-left: 5px solid transparent;
    border-right: 5px solid transparent;
    border-bottom: 5px solid black;
    z-index: 999;
    position:absolute;
    white-space:nowrap;
    top:17px;
    left: 0px;
}

.center {
  margin-left: auto;
  margin-right: auto;
}

</style>


<title>D3.js - Force Directed Layout</title>

<script>
        function enableDrawResume() {
            document.getElementById("drawButton").disabled = false;
            document.getElementById("resumeButton").disabled = false;
        }
</script>


</head>
<body id="body">
<center><h3>D3.js Force Layout Tester</h3></center>

<table class="center">
<tr>
	<td>
             <input type="button" id="useDefault" value="Use default data" onclick="useDefaultData();" />
        </td>
	<td>
             <button id="drawButton" onClick="draw()" style="width:81px" disabled>Draw</button>
        </td>
</tr><tr>
	<td>
             <input type="button" id="loadFileFromClient" value="Load from client" onclick="document.getElementById('files').click();" />
             <input type="file" style="display:none;" id="files" name="file" accept=".json" onclick="enableDrawResume()"/>
             <!--input type="file" id="files" name="file" accept=".json" onclick="enableDrawResume()"/-->
        </td>
	<td><button id="resumeButton" onClick="resume()" style="width:81px" disabled>Resume</button></td>
</tr>
</table>



<p id="lista"></p>

<center>
<svg style="border-style: solid"/>
</center>

<table class="center">
<tr>
</tr>
<tr>
	<td align="right">Charge:</td>
	<td>
		<input id="charge" type="number" value="-120" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="A negative value (default=-30) results in node repulsion, while a positive value results in node attraction. For graph layout, negative values should be used."><img src="images/question_mark_icon.gif"></a>
	</td>
	<td>&nbsp;&nbsp;&nbsp;</td>

	<td align="right">Gravity:</td>
	<td><input id="gravity" type="number" value="0.1" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="Gravity (default=0.1) is implemented as a weak geometric constraint similar to a virtual spring connecting each node to the center of the layout's size."><img src="images/question_mark_icon.gif"></a>
	</td>
	<td>&nbsp;&nbsp;&nbsp;</td>

	<td align="right">Alpha:</td>
	<td><input id="alpha" type="number" value="0.1" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="The layout temperature (default=0.1): it is decremented during the simulation, causing nodes to move more slowly. When alpha drops below a threshold the simulation stops completely."><img src="images/question_mark_icon.gif"></a>
	</td>
</tr><tr>
	<td align="right">Link Distance:</td>
	<td><input id="linkDistance" type="number" value="50" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="The target distance between linked nodes (default=20). For each iteration of the layout algorithm, the distance between each pair of linked nodes is computed and compared to the target distance."><img src="images/question_mark_icon.gif"></a>
	</td>
	<td>&nbsp;&nbsp;&nbsp;</td>

	<td align="right">Friction:</td>
	<td><input id="friction" type="number" value="0.9" max="0.99" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="Approximates velocity decay (default=0.9): at each iteration, the particle velocity is scaled by the specified friction. Values should be in [0,1] (0 = all nodes are frozen in place; 1 = frictionless)."><img src="images/question_mark_icon.gif"></a>
	</td>
	<td>&nbsp;&nbsp;&nbsp;</td>

	<td align="right">Charge Distance:</td>
	<td><input id="chargeDistance" type="number" value="1000" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="The maximum distance (default=infinite) over which charge forces are applied. Specifying a finite charge distance improves the performance and produces a more localized layout."><img src="images/question_mark_icon.gif"></a>
	</td>
<tr>
	<td align="right">Link Strength:</td>
	<td><input id="linkStrength" type="number" value="1" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="The link strength (default=1) is the rigidity of links. Should be in the range [0,1] where 0 = links are ignored and 1 = links are taken into account."><img src="images/question_mark_icon.gif"></a>
	</td>
	<td>&nbsp;&nbsp;&nbsp;</td>

	<td align="right">Theta:</td>
	<td><input id="theta" type="number" value="0.8" onchange="resume()">
		<a href="#" class="tooltip" data-tooltip="The Barnes-Hut approximation criterion (default=0.8). If the area of a quadrant in the quadtree over the distance between the quadrant and the node is less than theta the quadrant is used aggregated."><img src="images/question_mark_icon.gif"></a></td>
</tr>
</table>

<!--   Cooling parameter: <input id="alpha" type="number" value="0.1"><br>-->
</body>

<script src="lib/d3.min.js"></script>
<script>
var listaLink='';
var primaVolta=true;
var svg = null;
var force = null;
var node;
var link;
var nodi = [];
var links =[];
var arrayNodi =[];
var select = d3.selectAll("select");
var reader
var daFile = false; // whether data comes from a file
var defaultData = false; // whether data is the default

function useDefaultData() {
	defaultData = true;
        enableDrawResume(); 
}

function handleFileSelect(evt) {
    	var file = evt.target.files[0]; // File object

    	// files is a FileList of File objects. List some properties.
   
	reader = new FileReader();
	reader.readAsText(file);
  	reader.onloadend= (function() {
  		// document.getElementById("addNode").disabled = true;
  		// document.getElementById("addLink").disabled = true;
  		daFile = true;
  	});
}


function addNode() {
	var x = document.getElementById("nodo").value;
	var nuovoNodo = true;
	var y = true;
	if(x=="") y = false;
	if (y){
		for(i=0; i<arrayNodi.length+1; i++){
			if(arrayNodi[i]==x){
				nuovoNodo=false;
			}
		}
	}
	if(y && nuovoNodo){
	var nodo = {nome: x, group: 1};
	nodi.push(nodo);
	document.getElementById("nodo").value = "";
	select.append("option")
		  .text(x);}
	else if (y){alert("Nodo gi aggiunto");}
	else {alert("Inserisci un nome per il nodo")}
}


function addLink(){
	var x = document.getElementById("link1").selectedIndex;
	var y = document.getElementById("link2").selectedIndex;
	
	if(x!=y){
		links.push({source: x, target: y, value: 1});
		var valx = document.getElementById("link1").value;
		var valy = document.getElementById("link2").value;
		listaLink += valx + ' -> ' + valy + '<br>';
		document.getElementById("lista").innerHTML=listaLink;
	}
	else {alert("Scegli nodi diversi")}
	
} 


function draw(){

	var width = 900;
        var height = 600;

	var color = d3.scale.category20();

 	var charge = document.getElementById("charge").value;
	var linkDistance = document.getElementById("linkDistance").value;
	var gravity = document.getElementById("gravity").value;
	var linkStrength = document.getElementById("linkStrength").value;
	var friction = document.getElementById("friction").value;
	var theta = document.getElementById("theta").value;
	var alpha = document.getElementById("alpha").value;
	var chargeDistance = document.getElementById("chargeDistance").value;
	
	force = d3.layout.force()
			.charge(charge)
			.linkDistance(linkDistance)
			.gravity(gravity)
			.friction(friction)
			.linkStrength(linkStrength)
			.size([width, height])
			.alpha(alpha)
			.theta(theta)
			.chargeDistance(chargeDistance);
	
	if (primaVolta==true) {
		primaVolta=false;
	} else {	
		node.remove();
		link.remove();
		svg.remove();
	}
        /*
	svg = d3.select("body").append("svg")
    				.attr("width", width)
    				.attr("height", height)
    				.attr("id", "svg")
    				.attr("style", "border-style: solid");
	*/
	svg = d3.select("svg").attr("width", width)
    			      .attr("height", height)
    			      .attr("id", "svg")
    			      .attr("style", "border-style: solid");
	if(daFile){
    		var graph = JSON.parse(reader.result);
    		nodi = graph.nodes;
    		links = graph.links;
    	}

        if(defaultData) {
		nodi = [
                          {"name":"Myriel","group":1},
                          {"name":"Napoleon","group":1},
                          {"name":"Mlle.Baptistine","group":1},
                          {"name":"Mme.Magloire","group":1},
                          {"name":"CountessdeLo","group":1},
                          {"name":"Geborand","group":1},
                          {"name":"Champtercier","group":1},
                          {"name":"Cravatte","group":1},
                          {"name":"Count","group":1},
                          {"name":"OldMan","group":1},
                          {"name":"Labarre","group":2},
                          {"name":"Valjean","group":2},
                          {"name":"Marguerite","group":3},
                          {"name":"Mme.deR","group":2},
                          {"name":"Isabeau","group":2},
                          {"name":"Gervais","group":2},
                          {"name":"Tholomyes","group":3},
                          {"name":"Listolier","group":3},
                          {"name":"Fameuil","group":3},
                          {"name":"Blacheville","group":3},
                          {"name":"Favourite","group":3},
                          {"name":"Dahlia","group":3},
                          {"name":"Zephine","group":3},
                          {"name":"Fantine","group":3},
                          {"name":"Mme.Thenardier","group":4},
                          {"name":"Thenardier","group":4},
                          {"name":"Cosette","group":5},
                          {"name":"Javert","group":4},
                          {"name":"Fauchelevent","group":0},
                          {"name":"Bamatabois","group":2},
                          {"name":"Perpetue","group":3},
                          {"name":"Simplice","group":2},
                          {"name":"Scaufflaire","group":2},
                          {"name":"Woman1","group":2},
                          {"name":"Judge","group":2},
                          {"name":"Champmathieu","group":2},
                          {"name":"Brevet","group":2},
                          {"name":"Chenildieu","group":2},
                          {"name":"Cochepaille","group":2},
                          {"name":"Pontmercy","group":4},
                          {"name":"Boulatruelle","group":6},
                          {"name":"Eponine","group":4},
                          {"name":"Anzelma","group":4},
                          {"name":"Woman2","group":5},
                          {"name":"MotherInnocent","group":0},
                          {"name":"Gribier","group":0},
                          {"name":"Jondrette","group":7},
                          {"name":"Mme.Burgon","group":7},
                          {"name":"Gavroche","group":8},
                          {"name":"Gillenormand","group":5},
                          {"name":"Magnon","group":5},
                          {"name":"Mlle.Gillenormand","group":5},
                          {"name":"Mme.Pontmercy","group":5},
                          {"name":"Mlle.Vaubois","group":5},
                          {"name":"Lt.Gillenormand","group":5},
                          {"name":"Marius","group":8},
                          {"name":"BaronessT","group":5},
                          {"name":"Mabeuf","group":8},
                          {"name":"Enjolras","group":8},
                          {"name":"Combeferre","group":8},
                          {"name":"Prouvaire","group":8},
                          {"name":"Feuilly","group":8},
                          {"name":"Courfeyrac","group":8},
                          {"name":"Bahorel","group":8},
                          {"name":"Bossuet","group":8},
                          {"name":"Joly","group":8},
                          {"name":"Grantaire","group":8},
                          {"name":"MotherPlutarch","group":9},
                          {"name":"Gueulemer","group":4},
                          {"name":"Babet","group":4},
                          {"name":"Claquesous","group":4},
                          {"name":"Montparnasse","group":4},
                          {"name":"Toussaint","group":5},
                          {"name":"Child1","group":10},
                          {"name":"Child2","group":10},
                          {"name":"Brujon","group":4},
                          {"name":"Mme.Hucheloup","group":8}
                     ];
	     links = [
                          {"source":1,"target":0,"value":1},
                          {"source":1,"target":0,"value":1},
                          {"source":2,"target":0,"value":8},
                          {"source":3,"target":0,"value":10},
                          {"source":3,"target":2,"value":6},
                          {"source":4,"target":0,"value":1},
                          {"source":5,"target":0,"value":1},
                          {"source":6,"target":0,"value":1},
                          {"source":7,"target":0,"value":1},
                          {"source":8,"target":0,"value":2},
                          {"source":9,"target":0,"value":1},
                          {"source":11,"target":10,"value":1},
                          {"source":11,"target":3,"value":3},
                          {"source":11,"target":2,"value":3},
                          {"source":11,"target":0,"value":5},
                          {"source":12,"target":11,"value":1},
                          {"source":13,"target":11,"value":1},
                          {"source":14,"target":11,"value":1},
                          {"source":15,"target":11,"value":1},
                          {"source":17,"target":16,"value":4},
                          {"source":18,"target":16,"value":4},
                          {"source":18,"target":17,"value":4},
                          {"source":19,"target":16,"value":4},
                          {"source":19,"target":17,"value":4},
                          {"source":19,"target":18,"value":4},
                          {"source":20,"target":16,"value":3},
                          {"source":20,"target":17,"value":3},
                          {"source":20,"target":18,"value":3},
                          {"source":20,"target":19,"value":4},
                          {"source":21,"target":16,"value":3},
                          {"source":21,"target":17,"value":3},
                          {"source":21,"target":18,"value":3},
                          {"source":21,"target":19,"value":3},
                          {"source":21,"target":20,"value":5},
                          {"source":22,"target":16,"value":3},
                          {"source":22,"target":17,"value":3},
                          {"source":22,"target":18,"value":3},
                          {"source":22,"target":19,"value":3},
                          {"source":22,"target":20,"value":4},
                          {"source":22,"target":21,"value":4},
                          {"source":23,"target":16,"value":3},
                          {"source":23,"target":17,"value":3},
                          {"source":23,"target":18,"value":3},
                          {"source":23,"target":19,"value":3},
                          {"source":23,"target":20,"value":4},
                          {"source":23,"target":21,"value":4},
                          {"source":23,"target":22,"value":4},
                          {"source":23,"target":12,"value":2},
                          {"source":23,"target":11,"value":9},
                          {"source":24,"target":23,"value":2},
                          {"source":24,"target":11,"value":7},
                          {"source":25,"target":24,"value":13},
                          {"source":25,"target":23,"value":1},
                          {"source":25,"target":11,"value":12},
                          {"source":26,"target":24,"value":4},
                          {"source":26,"target":11,"value":31},
                          {"source":26,"target":16,"value":1},
                          {"source":26,"target":25,"value":1},
                          {"source":27,"target":11,"value":17},
                          {"source":27,"target":23,"value":5},
                          {"source":27,"target":25,"value":5},
                          {"source":27,"target":24,"value":1},
                          {"source":27,"target":26,"value":1},
                          {"source":28,"target":11,"value":8},
                          {"source":28,"target":27,"value":1},
                          {"source":29,"target":23,"value":1},
                          {"source":29,"target":27,"value":1},
                          {"source":29,"target":11,"value":2},
                          {"source":30,"target":23,"value":1},
                          {"source":31,"target":30,"value":2},
                          {"source":31,"target":11,"value":3},
                          {"source":31,"target":23,"value":2},
                          {"source":31,"target":27,"value":1},
                          {"source":32,"target":11,"value":1},
                          {"source":33,"target":11,"value":2},
                          {"source":33,"target":27,"value":1},
                          {"source":34,"target":11,"value":3},
                          {"source":34,"target":29,"value":2},
                          {"source":35,"target":11,"value":3},
                          {"source":35,"target":34,"value":3},
                          {"source":35,"target":29,"value":2},
                          {"source":36,"target":34,"value":2},
                          {"source":36,"target":35,"value":2},
                          {"source":36,"target":11,"value":2},
                          {"source":36,"target":29,"value":1},
                          {"source":37,"target":34,"value":2},
                          {"source":37,"target":35,"value":2},
                          {"source":37,"target":36,"value":2},
                          {"source":37,"target":11,"value":2},
                          {"source":37,"target":29,"value":1},
                          {"source":38,"target":34,"value":2},
                          {"source":38,"target":35,"value":2},
                          {"source":38,"target":36,"value":2},
                          {"source":38,"target":37,"value":2},
                          {"source":38,"target":11,"value":2},
                          {"source":38,"target":29,"value":1},
                          {"source":39,"target":25,"value":1},
                          {"source":40,"target":25,"value":1},
                          {"source":41,"target":24,"value":2},
                          {"source":41,"target":25,"value":3},
                          {"source":42,"target":41,"value":2},
                          {"source":42,"target":25,"value":2},
                          {"source":42,"target":24,"value":1},
                          {"source":43,"target":11,"value":3},
                          {"source":43,"target":26,"value":1},
                          {"source":43,"target":27,"value":1},
                          {"source":44,"target":28,"value":3},
                          {"source":44,"target":11,"value":1},
                          {"source":45,"target":28,"value":2},
                          {"source":47,"target":46,"value":1},
                          {"source":48,"target":47,"value":2},
                          {"source":48,"target":25,"value":1},
                          {"source":48,"target":27,"value":1},
                          {"source":48,"target":11,"value":1},
                          {"source":49,"target":26,"value":3},
                          {"source":49,"target":11,"value":2},
                          {"source":50,"target":49,"value":1},
                          {"source":50,"target":24,"value":1},
                          {"source":51,"target":49,"value":9},
                          {"source":51,"target":26,"value":2},
                          {"source":51,"target":11,"value":2},
                          {"source":52,"target":51,"value":1},
                          {"source":52,"target":39,"value":1},
                          {"source":53,"target":51,"value":1},
                          {"source":54,"target":51,"value":2},
                          {"source":54,"target":49,"value":1},
                          {"source":54,"target":26,"value":1},
                          {"source":55,"target":51,"value":6},
                          {"source":55,"target":49,"value":12},
                          {"source":55,"target":39,"value":1},
                          {"source":55,"target":54,"value":1},
                          {"source":55,"target":26,"value":21},
                          {"source":55,"target":11,"value":19},
                          {"source":55,"target":16,"value":1},
                          {"source":55,"target":25,"value":2},
                          {"source":55,"target":41,"value":5},
                          {"source":55,"target":48,"value":4},
                          {"source":56,"target":49,"value":1},
                          {"source":56,"target":55,"value":1},
                          {"source":57,"target":55,"value":1},
                          {"source":57,"target":41,"value":1},
                          {"source":57,"target":48,"value":1},
                          {"source":58,"target":55,"value":7},
                          {"source":58,"target":48,"value":7},
                          {"source":58,"target":27,"value":6},
                          {"source":58,"target":57,"value":1},
                          {"source":58,"target":11,"value":4},
                          {"source":59,"target":58,"value":15},
                          {"source":59,"target":55,"value":5},
                          {"source":59,"target":48,"value":6},
                          {"source":59,"target":57,"value":2},
                          {"source":60,"target":48,"value":1},
                          {"source":60,"target":58,"value":4},
                          {"source":60,"target":59,"value":2},
                          {"source":61,"target":48,"value":2},
                          {"source":61,"target":58,"value":6},
                          {"source":61,"target":60,"value":2},
                          {"source":61,"target":59,"value":5},
                          {"source":61,"target":57,"value":1},
                          {"source":61,"target":55,"value":1},
                          {"source":62,"target":55,"value":9},
                          {"source":62,"target":58,"value":17},
                          {"source":62,"target":59,"value":13},
                          {"source":62,"target":48,"value":7},
                          {"source":62,"target":57,"value":2},
                          {"source":62,"target":41,"value":1},
                          {"source":62,"target":61,"value":6},
                          {"source":62,"target":60,"value":3},
                          {"source":63,"target":59,"value":5},
                          {"source":63,"target":48,"value":5},
                          {"source":63,"target":62,"value":6},
                          {"source":63,"target":57,"value":2},
                          {"source":63,"target":58,"value":4},
                          {"source":63,"target":61,"value":3},
                          {"source":63,"target":60,"value":2},
                          {"source":63,"target":55,"value":1},
                          {"source":64,"target":55,"value":5},
                          {"source":64,"target":62,"value":12},
                          {"source":64,"target":48,"value":5},
                          {"source":64,"target":63,"value":4},
                          {"source":64,"target":58,"value":10},
                          {"source":64,"target":61,"value":6},
                          {"source":64,"target":60,"value":2},
                          {"source":64,"target":59,"value":9},
                          {"source":64,"target":57,"value":1},
                          {"source":64,"target":11,"value":1},
                          {"source":65,"target":63,"value":5},
                          {"source":65,"target":64,"value":7},
                          {"source":65,"target":48,"value":3},
                          {"source":65,"target":62,"value":5},
                          {"source":65,"target":58,"value":5},
                          {"source":65,"target":61,"value":5},
                          {"source":65,"target":60,"value":2},
                          {"source":65,"target":59,"value":5},
                          {"source":65,"target":57,"value":1},
                          {"source":65,"target":55,"value":2},
                          {"source":66,"target":64,"value":3},
                          {"source":66,"target":58,"value":3},
                          {"source":66,"target":59,"value":1},
                          {"source":66,"target":62,"value":2},
                          {"source":66,"target":65,"value":2},
                          {"source":66,"target":48,"value":1},
                          {"source":66,"target":63,"value":1},
                          {"source":66,"target":61,"value":1},
                          {"source":66,"target":60,"value":1},
                          {"source":67,"target":57,"value":3},
                          {"source":68,"target":25,"value":5},
                          {"source":68,"target":11,"value":1},
                          {"source":68,"target":24,"value":1},
                          {"source":68,"target":27,"value":1},
                          {"source":68,"target":48,"value":1},
                          {"source":68,"target":41,"value":1},
                          {"source":69,"target":25,"value":6},
                          {"source":69,"target":68,"value":6},
                          {"source":69,"target":11,"value":1},
                          {"source":69,"target":24,"value":1},
                          {"source":69,"target":27,"value":2},
                          {"source":69,"target":48,"value":1},
                          {"source":69,"target":41,"value":1},
                          {"source":70,"target":25,"value":4},
                          {"source":70,"target":69,"value":4},
                          {"source":70,"target":68,"value":4},
                          {"source":70,"target":11,"value":1},
                          {"source":70,"target":24,"value":1},
                          {"source":70,"target":27,"value":1},
                          {"source":70,"target":41,"value":1},
                          {"source":70,"target":58,"value":1},
                          {"source":71,"target":27,"value":1},
                          {"source":71,"target":69,"value":2},
                          {"source":71,"target":68,"value":2},
                          {"source":71,"target":70,"value":2},
                          {"source":71,"target":11,"value":1},
                          {"source":71,"target":48,"value":1},
                          {"source":71,"target":41,"value":1},
                          {"source":71,"target":25,"value":1},
                          {"source":72,"target":26,"value":2},
                          {"source":72,"target":27,"value":1},
                          {"source":72,"target":11,"value":1},
                          {"source":73,"target":48,"value":2},
                          {"source":74,"target":48,"value":2},
                          {"source":74,"target":73,"value":3},
                          {"source":75,"target":69,"value":3},
                          {"source":75,"target":68,"value":3},
                          {"source":75,"target":25,"value":3},
                          {"source":75,"target":48,"value":1},
                          {"source":75,"target":41,"value":1},
                          {"source":75,"target":70,"value":1},
                          {"source":75,"target":71,"value":1},
                          {"source":76,"target":64,"value":1},
                          {"source":76,"target":65,"value":1},
                          {"source":76,"target":66,"value":1},
                          {"source":76,"target":63,"value":1},
                          {"source":76,"target":62,"value":1},
                          {"source":76,"target":48,"value":1},
                          {"source":76,"target":58,"value":1}
                    ];
        }
    			
	force.nodes(nodi)
		.links(links)
		.start();

	link = svg.selectAll(".link")
				.data(links)
    				.enter().append("line")
      				.attr("class", "link")
      				.style("stroke-width", function(d) { return Math.sqrt(d.value); });

	node = svg.selectAll(".node")
      				.data(nodi)
				.enter().append("circle")
				.attr("class", "node")
				.attr("r", 5)
				.style("fill", function(d) { return color(d.group); })
      				.call(force.drag);



	node.append("title")
		.text(function(d) { return d.name; });

    force.on("tick", function() {
    link.attr("x1", function(d) { return d.source.x; })
        .attr("y1", function(d) { return d.source.y; })
        .attr("x2", function(d) { return d.target.x; })
        .attr("y2", function(d) { return d.target.y; });

    node.attr("cx", function(d) { return d.x; })
        .attr("cy", function(d) { return d.y; }); 
  });   

}
 
function resume(){

	var width = 900;
        var height = 600;

 	var charge = document.getElementById("charge").value;
	var linkDistance = document.getElementById("linkDistance").value;
	var gravity = document.getElementById("gravity").value;
	var linkStrength = document.getElementById("linkStrength").value;
	var friction = document.getElementById("friction").value;
	var theta = document.getElementById("theta").value;
	var alpha = document.getElementById("alpha").value;
	var chargeDistance = document.getElementById("chargeDistance").value;
	
	force.charge(charge)
		.linkDistance(linkDistance)
		.gravity(gravity)
		.friction(friction)
		.linkStrength(linkStrength)
		.size([width, height])
		.alpha(alpha)
		.theta(theta)
		.chargeDistance(chargeDistance);

	
	force.start();

}

 document.getElementById('files').addEventListener('change', handleFileSelect, false);
</script>
<p align="right">Thanks to Matteo Bellatreccia</p>
</html>
